#include <stdio.h>
#include <CopleyCAN.h>

int main( void )
{
   int i, err;
   void *cc;
   CanFrame frame;
   
   cc = CopleyCanOpen( 0, COPLEYCAN_BITRATE_1000000, &err );
   if( !cc )
   {
      printf( "Error opening CAN port: %d\n", err );
      return 1;
   }

   printf( "Waiting on message\n" );
   err = CopleyCanRecv( cc, &frame, 5000 );
   if( err )
   {
      printf( "Error %d waiting on message\n", err );
   }
   else
   {
      printf( "Received: 0x%08x ", frame.id );
      for( i=0; i<frame.length; i++ )
	 printf( "0x%02x ", frame.data[i] );
      printf( "\n" );
   }

   printf( "Sending message\n" );
   frame.type = CAN_FRAME_DATA;
   frame.id = 0x123;
   frame.length = 8;
   for( i=0; i<8; i++ )
      frame.data[i] = 0x11 * (i+1);

   err = CopleyCanXmit( cc, &frame, 1000 );
   if( err )
      printf( "Error %d sending frame\n", err );

   getchar();
   printf( "Closing port\n" );
   err = CopleyCanClose( cc );
   if( err )
      printf( "Error %d closing port\n", err );

   return 0;
}
